<template>
	<div class="app-container">
		<el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
			<el-form-item label="sn" prop="sn">
				<el-input v-model="queryParams.sn" placeholder="请输入sn" clearable @keyup.enter="handleQuery"
					:size="$store.state.app.size" />
			</el-form-item>
			<el-form-item>
				<el-button type="primary" icon="Search" @click="handleQuery"
					:size="$store.state.app.size">搜索</el-button>
				<el-button icon="Refresh" @click="resetQuery">重置</el-button>
			</el-form-item>
		</el-form>

		<el-row :gutter="10" class="mb8">
			<el-col :span="1.5">
				<el-button type="primary" plain icon="Plus" @click="handleAdd"
					v-hasPermi="['cameraConfig:cameraConfig:add']">新增
				</el-button>
			</el-col>
			<el-col :span="1.5">
				<el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
					v-hasPermi="['cameraConfig:cameraConfig:edit']">修改
				</el-button>
			</el-col>
			<el-col :span="1.5">
				<el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
					v-hasPermi="['cameraConfig:cameraConfig:remove']">删除
				</el-button>
			</el-col>
			<el-col :span="1.5">
				<el-button type="warning" plain icon="Download" @click="handleExport"
					v-hasPermi="['cameraConfig:cameraConfig:export']">导出
				</el-button>
			</el-col>
			<right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
		</el-row>

		<el-table v-loading="loading" :data="cameraConfigList" @selection-change="handleSelectionChange">
			<el-table-column type="selection" width="55" align="center" />
			<!-- <el-table-column label="主键" align="center" prop="cameraConfigId" /> -->
			<el-table-column label="sn" align="center" prop="sn" />
			<el-table-column label="萤石云key" align="center" prop="appKey" />
			<el-table-column label="萤石云密码" align="center" prop="appSecret" />
			<el-table-column label="序列号" align="center" prop="deviceSerial" />
			<el-table-column label="压缩账号" align="center" prop="username" />
			<el-table-column label="压缩密码" align="center" prop="password" />
			<el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="200" fixed="right">
				<template #default="scope">
					<!-- 	<el-button link type="primary" icon="View" @click="handleView(scope.row)"
						v-hasPermi="['cameraConfig:cameraConfig:query']">详细
					</el-button> -->
					<el-button link type="success" icon="Edit" @click="handleUpdate(scope.row)"
						v-hasPermi="['cameraConfig:cameraConfig:edit']">修改
					</el-button>
					<el-button link type="danger" icon="Delete" @click="handleDelete(scope.row)"
						v-hasPermi="['cameraConfig:cameraConfig:remove']">删除
					</el-button>
				</template>
			</el-table-column>
		</el-table>

		<pagination v-show="total>0" :total="total" v-model:page="queryParams.pageNum"
			v-model:limit="queryParams.pageSize" @pagination="getList" />

		<!-- 添加或修改摄像头配置对话框 -->
		<el-dialog :title="title" v-model="open" width="500px" append-to-body>
			<el-form ref="cameraConfigRef" :model="form" :rules="rules" label-width="100px">
				<el-form-item label="sn" prop="sn">
					<el-input v-model="form.sn" placeholder="请输入sn" />
				</el-form-item>
				<el-form-item label="萤石云key" prop="appKey">
					<el-input v-model="form.appKey" placeholder="请输入萤石云key" />
				</el-form-item>
				<el-form-item label="萤石云密码" prop="appSecret">
					<el-input v-model="form.appSecret" placeholder="请输入萤石云密码" />
				</el-form-item>
				<el-form-item label="序列号" prop="deviceSerial">
					<el-input v-model="form.deviceSerial" placeholder="请输入序列号" />
				</el-form-item>
				<el-form-item label="压缩账号" prop="username">
					<el-input v-model="form.username" placeholder="请输入压缩账号" />
				</el-form-item>
				<el-form-item label="压缩密码" prop="password">
					<el-input v-model="form.password" placeholder="请输入压缩密码" />
				</el-form-item>
			</el-form>
			<template #footer>
				<div class="dialog-footer">
					<el-button type="primary" @click="submitForm">确 定</el-button>
					<el-button @click="cancel">取 消</el-button>
				</div>
			</template>
		</el-dialog>
	</div>





</template>

<script setup name="CameraConfig">
	import {
		listCameraConfig,
		getCameraConfig,
		delCameraConfig,
		addCameraConfig,
		updateCameraConfig
	} from "@/api/cameraConfig/cameraConfig";

	const {
		proxy
	} = getCurrentInstance();
	const cameraConfigList = ref([]);
	const open = ref(false);
	const loading = ref(true);
	const showSearch = ref(true);
	const ids = ref([]);
	const single = ref(true);
	const multiple = ref(true);
	const total = ref(0);
	const title = ref("");

	const data = reactive({
		form: {},
		queryParams: {
			pageNum: 1,
			pageSize: 10,
			sn: null,
		},
		rules: {
			sn: [{
				required: true,
				message: "sn不能为空",
				trigger: "blur"
			}],
			appKey: [{
				required: true,
				message: "萤石云key不能为空",
				trigger: "blur"
			}],
			appSecret: [{
				required: true,
				message: "萤石云密码不能为空",
				trigger: "blur"
			}],
			deviceSerial: [{
				required: true,
				message: "序列号不能为空",
				trigger: "blur"
			}],
		}
	});

	const {
		queryParams,
		form,
		rules
	} = toRefs(data);
	const baseUrl = import.meta.env.VITE_APP_BASE_API;

	/** 查询摄像头配置列表 */
	function getList() {
		loading.value = true;
		listCameraConfig(queryParams.value).then(response => {
			cameraConfigList.value = response.rows;
			total.value = response.total;
			loading.value = false;
		});
	}

	function addList() {
		loading.value = true;
		listCameraConfig(queryParams.value)
			.then(response => {
				cameraConfigList.value.push(...response.rows);
				total.value = response.total;
				if (cameraConfigList.value.length >= total.value) finished.value = true;
				loading.value = false;
			})
			.catch(response => {
				loading.value = false;
			});
	}

	// 下拉刷新
	function handlePullDownRefresh() {
		queryParams.value.pageNum = 1;
		cameraConfigList.value = [];
		addList();
	}

	// 滚动到底部的事件
	function handleReachBottom() {
		queryParams.value.pageNum++;
		addList();
	}

	// 取消按钮
	function cancel() {
		open.value = false;
		reset();
	}

	// 表单重置
	function reset() {
		form.value = {
			cameraConfigId: null,
			sn: null,
			appKey: null,
			appSecret: null,
			deviceSerial: null,
			username: null,
			password: null,
			createBy: null,
			createTime: null,
			updateBy: null,
			updateTime: null
		};
		proxy.resetForm("cameraConfigRef");
	}

	/** 搜索按钮操作 */
	function handleQuery() {
		queryParams.value.pageNum = 1;
		getList();
	}

	/** 重置按钮操作 */
	function resetQuery() {
		proxy.resetForm("queryRef");
		handleQuery();
	}

	// 多选框选中数据
	function handleSelectionChange(selection) {
		ids.value = selection.map(item => item.cameraConfigId);
		single.value = selection.length != 1;
		multiple.value = !selection.length;
	}

	/** 新增按钮操作 */
	function handleAdd() {
		reset();
		open.value = true;
		title.value = "添加摄像头配置";
	}

	/** 修改按钮操作 */
	function handleUpdate(row) {
		reset();
		const cameraConfigId =
			row.cameraConfigId || ids.value
		getCameraConfig(cameraConfigId).then(response => {
			form.value = response.data;
			open.value = true;
			title.value = "修改摄像头配置";
		});
	}

	/** 提交按钮 */
	function submitForm() {
		proxy.$refs["cameraConfigRef"].validate(valid => {
			if (valid) {
				if (form.value.cameraConfigId != null) {
					updateCameraConfig(form.value).then(response => {
						proxy.$modal.msgSuccess("修改成功");
						open.value = false;
						getList();
					});
				} else {
					addCameraConfig(form.value).then(response => {
						proxy.$modal.msgSuccess("新增成功");
						open.value = false;
						getList();
					});
				}
			}
		});
	}

	/** 删除按钮操作 */
	function handleDelete(row) {
		const cameraConfigIds = row.cameraConfigId || ids.value;
		proxy.$modal.confirm('是否确认删除摄像头配置编号为"' + cameraConfigIds + '"的数据项？').then(function() {
			return delCameraConfig(cameraConfigIds);
		}).then(() => {
			getList();
			proxy.$modal.msgSuccess("删除成功");
		}).catch(() => {});
	}

	/** 导出按钮操作 */
	function handleExport() {
		downloadCameraConfig(queryParams.value)
		// proxy.download('cameraConfig/cameraConfig/export', {
		//   ...queryParams.value
		// }, `cameraConfig_${new Date().getTime()}.xlsx`)
	}

	/** 详细按钮操作 */
	function handleView(row) {}


	onMounted(() => {
		queryParams.value.sn = proxy.$route.query.sn
		getList();
	})
</script>